/////////////////////////////////////////////////////////////////////
// Example : Automatica 2001
//           "Model reference control for timed event graphs in dioids"
//         
//
/////////////////////////////////////////////////////////////////////

mode(-1);

    A=smatrix(3,3); //matrice d'tat
    H = smatrix(1,2);
    CA = smatrix(1,3);
    Gref = smatrix(1,2);
    E = smatrix(2,2);
    
mode(7);
//state matrix declaration
    A(1,1)=series(eps,[1 2],e); 
	A(2,2)=series(eps,[1 3],e);
	A(3,1)=series(eps,[1 3],e);
	A(3,2)=series(eps,[0 8],e);
	A(3,3)=series(eps,[1 2],e)
	         

// input and output matrices
    B = smatrix(3,2);
    C = smatrix(1,3);
    
    C(1,3)=series(eps,[0 2],e)	
	
    B(1,1)=s_e;	// x1=u1
    B(2,2)=s_e	// x6=u2

               
    CA= C*stargd(A)  // CA*
       
     
    H=CA*B // input/output transfer CA*B
	
    s1 = series(eps,e,[1 3]);

//reference model declaration	
    Gref(1,1)=H(1,1)*s1;
	Gref(1,2)=H(1,2)*s1


		
// Output feedback on optimal state Sr=(CA*)\Gref/H
// periodic Feedback Sr 	
	Sr=  CA \ Gref / H
	
// Causal Feedback sr
	Sr=prcaus(Sr)

	
// Controlled System Gbf=((CA*Sr)*)H
// System in closed-loop	

    Gbfsr= stargd(CA*Sr)*H  
  
   